#ifndef CANBUSID_H
#define CANBUSID_H

// Notes:
//
//  Highest Priority message ID = 0b000000 00000 = 0x000 = ((0x00 << 5) | 0x00)
//  Lowest  Priority message ID = 0b111111 11111 = 0x7FF = ((0x3F << 5) | 0x1F)

enum CAN_MESSAGE_IDS_ENUM
{
    IMUID = (0x04 << 5),
    IMURate = (IMUID | 4),
    IMURateDiv = (IMUID | 8),
    IMUAccel = (IMUID | (4 << 2)),
    IMUGyro = (IMUID | (5 << 2)),

    GPSID = (0x06 << 5),
    GPSStatus = (GPSID | 1),
    GPSTime = (GPSID | 2),
    GPSLatLon = (GPSID | 3),
    GPSHeight = (GPSID | 4),

    PressID = (0x07 << 5),
    PressValue = (PressID | (3 << 3)),

    // Umbilical CAN messages

    can_id_umbilical =              (0x08 << 0x05),            // receive only
    can_id_umbilical_error =        (can_id_umbilical | 0x01), // transmit only
    can_id_umbilical_rocketready =  (can_id_umbilical | 0x02), // receive only
    can_id_umbilical_connection =   (can_id_umbilical | 0x03), // transmit/rtr
    can_id_umbilical_voltage =      0b0010000010000000, //(can_id_umbilical | 0x04), // transmit/rtr

    // Power System CAN messages

    can_id_power =                  (0x09 << 0x05),            // receive only
    can_id_power_error =            (can_id_power | 0x01),     // transmit only
    can_id_power_change_state =     (can_id_power | 0x02),     // receive only
    can_id_power_state =            (can_id_power | 0x03),     // transmit/rtr
    can_id_power_voltage =          (can_id_power | 0x04),     // transmit only
    can_id_power_current =          (can_id_power | 0x05),     // transmit only

    // ATV CAN messages


    ATVID = (0x10 << 5),
    ATVStatus = (ATVID | 1),
    ATVAmpPower = (ATVID | 2),
    ATVOverlay = (ATVID | 3),

    TempID = (0x14 << 5),
    TempValue = (TempID | (3 << 3)),
};

#endif
